package   cohy.correlator;

import 	  rsf.vector.*;
import  juice.util.Tester;
import  juice.vector.*;
/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class TraceCorrelatorTest {
  public static void main(String[] args) {

    boolean correct = true;

    int r0 = 3;
    Rsf1 rand1 = (Rsf1) RsfFactory.newRsf(r0);
    rand1.rand();

    System.out.println("2-D test");
    int r1 = 4;
    Rsf2 rand2 = (Rsf2) RsfFactory.newRsf(r0,r1);
    for (int i1=0; i1<r1; i1++) 
      System.arraycopy(rand1.d,0,rand2.d[i1],0,r0);
    RealVec oput2 = new RealVec();
    TraceCorrelator auto2 = new TraceCorrelator(rand2.getSpace());
    auto2.image(rand2, oput2);
    if (oput2.getValue() !=  1.f) correct = false;
    System.out.println("correlation should be  1: " + oput2.getValue());

    Rsf2 iput2 = (Rsf2) RsfFactory.newRsf(3,4);
    iput2.d[0][0] =  3.f; iput2.d[2][0] = -1.f;    
    iput2.d[0][1] =  2.f; iput2.d[2][1] =  0.f;
    iput2.d[0][2] =  5.f; iput2.d[2][2] =  1.f;
    iput2.d[1][0] =  3.f; iput2.d[3][0] = -1.f;    
    iput2.d[1][1] =  2.f; iput2.d[3][1] =  0.f;
    iput2.d[1][2] =  5.f; iput2.d[3][2] =  1.f;
    TraceCorrelator cross2 = new TraceCorrelator(iput2.getSpace());
    cross2.image(iput2,oput2);
    if (oput2.getValue() >=  0.486278f) correct = false;
    if (oput2.getValue() <=  0.486276f) correct = false;
    System.out.println("correlation should be 0.486277: " + oput2.getValue());

    System.out.println("3-D test");
    int r2 = 7;
    Rsf3 rand3 = (Rsf3) RsfFactory.newRsf(r0,r1,r2);
    for   (int i2=0; i2<r2; i2++) 
      for (int i1=0; i1<r1; i1++) 
	System.arraycopy(rand1.d,0,rand3.d[i2][i1],0,r0);
    RealVec oput3 = new RealVec();
    TraceCorrelator auto3 = new TraceCorrelator(rand3.getSpace());
    auto3.image(rand3, oput3);
    if (oput3.getValue() !=  1.f) correct = false;
    System.out.println("correlation should be  1: " + oput3.getValue());

    Rsf3 iput3 = (Rsf3) RsfFactory.newRsf(3,2,4);
    iput3.d[0][0][0] =  3.f; iput3.d[2][0][0] = -1.f;    
    iput3.d[0][0][1] =  2.f; iput3.d[2][0][1] =  0.f;
    iput3.d[0][0][2] =  5.f; iput3.d[2][0][2] =  1.f;
    iput3.d[0][1][0] =  3.f; iput3.d[2][1][0] = -1.f;    
    iput3.d[0][1][1] =  2.f; iput3.d[2][1][1] =  0.f;
    iput3.d[0][1][2] =  5.f; iput3.d[2][1][2] =  1.f;
    iput3.d[1][0][0] =  3.f; iput3.d[3][0][0] = -1.f;    
    iput3.d[1][0][1] =  2.f; iput3.d[3][0][1] =  0.f;
    iput3.d[1][0][2] =  5.f; iput3.d[3][0][2] =  1.f;
    iput3.d[1][1][0] =  3.f; iput3.d[3][1][0] = -1.f;    
    iput3.d[1][1][1] =  2.f; iput3.d[3][1][1] =  0.f;
    iput3.d[1][1][2] =  5.f; iput3.d[3][1][2] =  1.f;
    TraceCorrelator cross3 = new TraceCorrelator(iput3.getSpace());
    cross3.image(iput3, oput3);
    if (oput3.getValue() >=  0.486278f) correct = false;
    if (oput3.getValue() <=  0.486276f) correct = false;
    System.out.println("correlation should be 0.486277: " + oput3.getValue());

    Tester.exit(correct);
  }
}

