package cohy.correlator;
import 	 sep.operator.*;
import   jam.vector.*;
import   juice.vector.*;
import	 rsf.vector.*;
import   sep.io.ArgumentKeeper;

/**
 * Fills the output Rsf with the correlation coefficient computed by 
 * TraceCorrelator for the given input Rsf.
 *
 * @see: TraceCorrelator 
 */
public class TraceCorrelatorToRsf extends SepOperator {
  TraceCorrelator corr;
  /**
   * Domain and Range space equals the signal space (better be RsfSpaces). 
   */
  public TraceCorrelatorToRsf(RsfSpace space) {
    this(space, space);
  }
  /**
   * The output space describes an Rsf that will be filled by the 
   * correlation coefficients (currently accepts RsfSpace or RealSpc).
   */
  public TraceCorrelatorToRsf(RsfSpace iputSpace, RsfSpace oputSpace) {
    super(iputSpace, oputSpace);
    this.corr = new TraceCorrelator(iputSpace); 
  }
  protected TraceCorrelatorToRsf(TraceCorrelatorToRsf src) {
    super(src);
    this.corr   = (TraceCorrelator) src.corr.copy();
  }
  public jam.JamObject copy() { return new TraceCorrelatorToRsf(this);}
  /**
   * I should probably call this createRange(). Defaults to RealSpc.
   */
  public static RsfSpace getOutputRsfSpace(RsfSpace iputSpace) {
    return iputSpace; 
  }

  protected void apply(boolean add, Vector iput, Vector oput) {
    RealVec dummy = new RealVec();
    corr.apply(add,iput,dummy);
    ((Rsf) oput).fill(dummy.getValue());
  }
}
