package   cohy.correlator;

import 	  rsf.vector.*;
import  juice.util.Tester;
import  juice.vector.*;
/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class TraceToTraceCorrTest {
  public static void main(String[] args) {

    boolean correct = true;

    System.out.println("1-D test");
    int n0 = 55;
    Rsf rand1 = RsfFactory.newRsf(n0);
    rand1.rand();
    Rsf oput1 = RsfFactory.newRsf(n0);
    TraceToTraceCorr auto1 = new TraceToTraceCorr(rand1);
    auto1.image(rand1, oput1);
    int[] ind1 = {0};
    for (int i0 = 0; i0 < n0; i0++) {
      ind1[0] = i0;
      if (oput1.getDatum(ind1) !=  1.f) correct = false;
    }
    System.out.println("correlation should be  1: " + oput1.getDatum(ind1));

    int m0 = 3;
    Rsf1 idat1 = (Rsf1) RsfFactory.newRsf(m0);
    Rsf1 odat1 = (Rsf1) RsfFactory.newRsf(m0);
    Rsf1 sgnl1 = (Rsf1) RsfFactory.newRsf(m0);
    idat1.d[0] =  3.f; sgnl1.d[0] = -1.f;    
    idat1.d[1] =  2.f; sgnl1.d[1] =  0.f;
    idat1.d[2] =  5.f; sgnl1.d[2] =  1.f;
    TraceToTraceCorr cross1 = new TraceToTraceCorr(sgnl1);
    cross1.image(idat1,odat1);
    for (int i0 = 0; i0 < m0; i0++) {
      ind1[0] = i0;
      if (odat1.getDatum(ind1) >=  0.229417f) correct = false;
      if (odat1.getDatum(ind1) <=  0.229415f) correct = false;
    }
    System.out.println("correlation should be " + Math.sqrt(1.f/19.f) + ": " + odat1.getDatum(ind1));

    System.out.println("2-D test");
    int n1 = 5;
    Rsf rand2 = RsfFactory.newRsf(n0,n1);
    rand2.rand();
    Rsf oput2 = RsfFactory.newRsf(n0,n1);
    TraceToTraceCorr auto2 = new TraceToTraceCorr(rand2);
    auto2.image(rand2, oput2);
    int[] ind2 = {0,0};
    for   (int i1 = 0; i1 < n1; i1++) { ind2[1] = i1;
      for (int i0 = 0; i0 < n0; i0++) { ind2[0] = i0; 
        if (oput2.getDatum(ind2) !=  1.f) correct = false;
    } }
    System.out.println("correlation should be  1: " + oput2.getDatum(ind2));

    int m1=2;
    Rsf2 idat2 = (Rsf2) RsfFactory.newRsf(m0,m1);
    Rsf2 odat2 = (Rsf2) RsfFactory.newRsf(m0,m1);
    Rsf2 sgnl2 = (Rsf2) RsfFactory.newRsf(m0,m1);
    idat2.d[0][0] =  3.f; sgnl2.d[0][0] = -1.f;    
    idat2.d[0][1] =  2.f; sgnl2.d[0][1] =  0.f;
    idat2.d[0][2] =  5.f; sgnl2.d[0][2] =  1.f;
    idat2.d[1][0] =  3.f; sgnl2.d[1][0] = -1.f;    
    idat2.d[1][1] =  2.f; sgnl2.d[1][1] =  0.f;
    idat2.d[1][2] =  5.f; sgnl2.d[1][2] =  1.f;
    TraceToTraceCorr cross2 = new TraceToTraceCorr(sgnl2);
    cross2.image(idat2,odat2);
    for   (int i1 = 0; i1 < m1; i1++) { ind2[1] = i1;
      for (int i0 = 0; i0 < m0; i0++) { ind2[0] = i0; 
      if (odat2.getDatum(ind2) >=  0.229417f) correct = false;
      if (odat2.getDatum(ind2) <=  0.229415f) correct = false;
    }}
    System.out.println("correlation should be " + Math.sqrt(1.f/19.f) + ": " + odat2.getDatum(ind2));

    System.out.println("3-D test");
    int n2 = 3;
    Rsf rand3 = RsfFactory.newRsf(n0,n1,n2);
    rand3.rand();
    Rsf oput3 = RsfFactory.newRsf(n0,n1,n2);
    TraceToTraceCorr auto3 = new TraceToTraceCorr(rand3);
    auto3.image(rand3, oput3);
    int[]  ind3 = {0,0,0};
    for     (int i2 = 0; i2 < n2; i2++) { ind3[2] = i2;
      for   (int i1 = 0; i1 < n1; i1++) { ind3[1] = i1;
        for (int i0 = 0; i0 < n0; i0++) { ind3[0] = i0; 
          if (oput3.getDatum(ind3) !=  1.f) correct = false;
    } } }
    System.out.println("correlation should be  1: " + oput3.getDatum(ind3));

    int m2=2;
    Rsf3 idat3 = (Rsf3) RsfFactory.newRsf(m0,m1,m2);
    Rsf3 odat3 = (Rsf3) RsfFactory.newRsf(m0,m1,m2);
    Rsf3 sgnl3 = (Rsf3) RsfFactory.newRsf(m0,m1,m2);
    idat3.d[0][0][0] =  3.f; sgnl3.d[0][0][0] = -1.f;    
    idat3.d[0][0][1] =  2.f; sgnl3.d[0][0][1] =  0.f;
    idat3.d[0][0][2] =  5.f; sgnl3.d[0][0][2] =  1.f;
    idat3.d[0][1][0] =  3.f; sgnl3.d[0][1][0] = -1.f;    
    idat3.d[0][1][1] =  2.f; sgnl3.d[0][1][1] =  0.f;
    idat3.d[0][1][2] =  5.f; sgnl3.d[0][1][2] =  1.f;
    idat3.d[1][0][0] =  3.f; sgnl3.d[1][0][0] = -1.f;    
    idat3.d[1][0][1] =  2.f; sgnl3.d[1][0][1] =  0.f;
    idat3.d[1][0][2] =  5.f; sgnl3.d[1][0][2] =  1.f;
    idat3.d[1][1][0] =  3.f; sgnl3.d[1][1][0] = -1.f;    
    idat3.d[1][1][1] =  2.f; sgnl3.d[1][1][1] =  0.f;
    idat3.d[1][1][2] =  5.f; sgnl3.d[1][1][2] =  1.f;
    TraceToTraceCorr cross3 = new TraceToTraceCorr(sgnl3);
    cross3.image(idat3,odat3);
    for     (int i2 = 0; i2 < m2; i2++) { ind3[2] = i2;
      for   (int i1 = 0; i1 < m1; i1++) { ind3[1] = i1;
        for (int i0 = 0; i0 < m0; i0++) { ind3[0] = i0; 
          if (odat3.getDatum(ind3) >=  0.229417f) correct = false;
          if (odat3.getDatum(ind3) <=  0.229415f) correct = false;
    } } }
    System.out.println("correlation should be " + Math.sqrt(1.f/19.f) + ": " + odat3.getDatum(ind3));

    Tester.exit(correct);
  }
}

