package  cohy.data;

import   jam.vector.*;
import	 rsf.vector.*;
import	 rsf.util.*;
import   sep.io.ArgumentKeeper;
/**
 * <BR><!--#include file="./source.inc"--><BR>
 * 
 * Normalizes the input elementwise, so that the maximal absolute value
 * is about 128. 
 */
public class Normalisor implements jam.operator.Operator { 
  Space spce ; 
  final float MAX =128.f;

  public Normalisor(Space spce) { 
    this.spce = spce; 
  }

  // operator superclass methods
  public jam.JamObject copy  () { return new Normalisor(spce); }

  public Vector image(Vector iput) {
    Vector oput = iput.getSpace().newMember();
    Attr   cntr = new Attr((Rsf) iput); 
    oput.copyFrom(iput); 
    oput.scale(MAX / cntr.getAbsMax());
    return oput;
  }
  /**
   * image(d,d) for in-place operation. (In general this is not 
   * a good idea but for elementwise operations such in-place 
   * operations are straightforward. 
   */
  public void image(Vector iput, Vector oput){
    Attr   cntr = new Attr((Rsf) iput); 
    oput.copyFrom(iput); 
    oput.scale(MAX / cntr.getAbsMax()); 
  }
  public void addImage(Vector iput, Vector oput){
    Attr   cntr = new Attr((Rsf) iput); 
    oput.addScale(MAX / cntr.getAbsMax(), iput); 
  } 
  public void residual(Vector d, Vector b, Vector r) {
    r.neg(b);
    addImage(d,r); 
  }

  public  Space getDomain         () { return spce; }
  public  Space getRange          () { return spce; }

  /**
   * Normalisor < notNormalized.H > normalized.H 
   */
  public static void main(String[] args) { 
    ArgumentKeeper argKeeper = new ArgumentKeeper(args);
    Rsf iput  = (Rsf) RsfFactory.newRsf(System.in);
    Normalisor op = new Normalisor(iput.getSpace());
    Rsf oput = (Rsf) op.image(iput); 
    oput.write(System.out); 
  }
}







