package cohy.estDip;

import   rsf.vector.*;

public class CmpSyn {
  public static void main(String[] args) {
    int n1 = 410; float d1 = .004f; 
    int n2 =  24; float d2 = .065f ; 
    Axis[] ax = new Axis[2];
    ax[0]     = new Axis(n1, d1 ,0.f, "time"  , "sec");
    ax[1]     = new Axis(n2, d2 ,0.f, "offset", "km" );
    Rsf cmp   = RsfFactory.newRsf(ax);

    // builds wavelet: isolate in shift method
    float t0=d1*n1/5, cycles = 4.f; 
    float[] wave = new float[n1];
    for(int i1=0; i1<n1; i1++) {
      double tt = -t0 + i1 * d1;
      if ( tt > 0.f ) 
	wave[i1] = (float)(Math.sin(6.28 * tt * cycles) * Math.exp(-tt));
      else 
	wave[i1] = 0.f;
    }

    int shift = 10; 
    float[][] data = ((Rsf2)cmp).d; 
    for(int i2=0; i2<n2; i2++) { 
    for(int i1=0; i1<n1; i1++) {
      double zsqrd = Math.pow((d1*(i1-1)),2) - Math.pow((d2*(i2-2)),2);
      if( zsqrd > 0. ) {
	int iz = (int)(Math.sqrt(zsqrd)/d1);
	if (i2 == 8) { 
	  if (iz-shift >= 1) data[i2][i1] = wave[iz-shift];
	}
	else {
	                     data[i2][i1] = wave[iz];
	}
      }
    }}
    cmp.write(System.out); 
  }
}
