package   cohy.estDip;

import 	  rsf.vector.*;
import  juice.util.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class DipXGradAndAdjTest {
  public static void main(String[] args) {

    int[] ind2 = {0, 0   };
    int[] ind3 = {0, 0, 0};

    boolean correct = true;

    System.out.println("2-D test");
    Rsf2 iput2 = (Rsf2) RsfFactory.newRsf(2,2);
    iput2.d[0][0] =  1.f;    iput2.d[1][0] =  3.f;
    iput2.d[0][1] =  2.f;    iput2.d[1][1] =  4.f;

    iput2.d[0][0] =  1.f;    iput2.d[1][0] =   1.f;
    iput2.d[0][1] = -1.f;    iput2.d[1][1] =  -1.f;

    DipXGradAndAdj oper2 = new DipXGradAndAdj((RsfSpace) iput2.getSpace());
    Rsf            oput2 = (Rsf) oper2.getRange().newMember();
    oper2.image(iput2,oput2); 

    if (oput2.getDatum(ind2) !=  0) correct = false;
    System.out.println("res should be  0: " + oput2.getDatum(ind2));

    System.out.println("3-D test");
    int[] smpl = {2,2,2}; 
    Rsf3 iput3 = (Rsf3) RsfFactory.newRsf(smpl);

    iput3.d[0][0][0] =   0.f;    iput3.d[1][0][0] =   1.f;
    iput3.d[0][1][0] =   1.f;    iput3.d[1][1][0] =   2.f;
    iput3.d[0][0][1] =   1.f;    iput3.d[1][0][1] =   2.f;
    iput3.d[0][1][1] =   2.f;    iput3.d[1][1][1] =   3.f;
    /*
    iput3.d[0][0][0] =   1.f;    iput3.d[1][0][0] =   1.f;
    iput3.d[0][1][0] =   1.f;    iput3.d[1][1][0] =   1.f;
    iput3.d[0][0][1] =  -1.f;    iput3.d[1][0][1] =  -1.f;
    iput3.d[0][1][1] =  -1.f;    iput3.d[1][1][1] =  -1.f;
    */
    DipXGradAndAdj oper3 = new DipXGradAndAdj((RsfSpace) iput3.getSpace());
    Rsf            oput3 = (Rsf) oper3.getRange().newMember();

    oper3.image(iput3,oput3); 
    int[] ind30 = {0,0,0}; if (oput3.getDatum(ind30) !=  0) correct = false;
    int[] ind31 = {0,1,0}; if (oput3.getDatum(ind31) !=  0) correct = false;
    int[] ind32 = {0,0,1}; if (oput3.getDatum(ind32) !=  0) correct = false;
    int[] ind33 = {0,1,1}; if (oput3.getDatum(ind33) !=  0) correct = false;

    int[] ind34 = {1,0,0}; if (oput3.getDatum(ind34) !=  0) correct = false;
    int[] ind35 = {1,1,0}; if (oput3.getDatum(ind35) !=  0) correct = false;
    int[] ind36 = {1,0,1}; if (oput3.getDatum(ind36) !=  0) correct = false;
    int[] ind37 = {1,1,1}; if (oput3.getDatum(ind37) !=  0) correct = false;
    System.out.println("oput should be all 0: " + oput3);

    System.err.println("Sample (1,1,0) deviates from plane-wave");
    iput3.d[0][0][0] =   0.f;    iput3.d[1][0][0] =   1.f;
    iput3.d[0][1][0] =   1.f;    iput3.d[1][1][0] =  12.f;
    iput3.d[0][0][1] =   1.f;    iput3.d[1][0][1] =   2.f;
    iput3.d[0][1][1] =   2.f;    iput3.d[1][1][1] =   3.f;

    oper3.image(iput3,oput3); 

    int[] ind40 = {0,0,0}; 
    correct = JuiceUtil.approx(oput3.getDatum(ind40),-3.97364e-06f);
    int[] ind41 = {0,1,0}; 
    correct = JuiceUtil.approx(oput3.getDatum(ind41),-5.24521e-06f);
    int[] ind42 = {0,0,1}; 
    correct = JuiceUtil.approx(oput3.getDatum(ind42), 1.58946e-06f);
    int[] ind43 = {0,1,1}; 
    correct = JuiceUtil.approx(oput3.getDatum(ind43), 3.17891e-07f);
    int[] ind44 = {1,0,0}; 
    correct = JuiceUtil.approx(oput3.getDatum(ind44),-3.17891e-07f);
    int[] ind45 = {1,1,0}; 
    correct = JuiceUtil.approx(oput3.getDatum(ind45),-1.58946e-06f);
    int[] ind46 = {1,0,1}; 
    correct = JuiceUtil.approx(oput3.getDatum(ind46), 5.24521e-06f);
    int[] ind47 = {1,1,1}; 
    correct = JuiceUtil.approx(oput3.getDatum(ind47), 3.97364e-06f);
    System.out.println("oput should be all 0: " + oput3);

    Tester.exit(correct);
  }
}

