package   cohy.estDip;

import 	  jam.vector.*;
import 	  jam.operator.*;
import 	  rsf.vector.*;

/**
 * Instantiates a DipXGrad operator. The optional constructor argument 
 * wantedResult should be set by one of DipXGrad's class variables,
 * e.g. DipXGrad.XCOMPONENT. Ignored in 2D case. Defaults to zero. 
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class DipXGradFactory implements OperatorFactory {
  int wantedResult; 
  public DipXGradFactory() {}
  public DipXGradFactory(int wantedResult) {
    this.wantedResult = wantedResult;
  }
  public Space createRange (Space domain){
    return DipXGrad.getOutputRsfSpace((RsfSpace) domain);
  }
  public Space createDomain(Space range ){
    return DipXGrad.getInputRsfSpace((RsfSpace) range);
  }
  public Operator getOp(Space domain, Space range ){
    DipXGrad d = new DipXGrad((RsfSpace) domain, (RsfSpace) range);
    d.setResult(wantedResult); 
    return d; 
  }
  public Operator getOpWithRange(Space range){
    DipXGrad d = new DipXGrad((RsfSpace)createDomain(range), (RsfSpace)range);
    d.setResult(wantedResult);
    return d;
  }
  public Operator getOpWithDomain(Space domain){
    DipXGrad d = new DipXGrad((RsfSpace)domain, (RsfSpace)createRange(domain));
    d.setResult(wantedResult); 
    return d;
  }
}




