package cohy.estDip;

import   jam.operator.*; 
import   rsf.vector.*;
import   rsf.operator.*; 
import   sep.io.ArgumentKeeper;
import  nstat.patch.*;

public class DipXGradNStat { 
  /** 
   * @param comp=[0,1,2] int   argument sets the component of the 3D operator
   *                           (see DipXGrad). Ignored in 2-D case. 
   * @param olap=.5f,.5f float array of overlap values 
   * @param psze=8,2     int   array of patch size 
   */ 
  public static void main(String[] args) {
    ArgumentKeeper cmd = new ArgumentKeeper(args); 

    Rsf iput = RsfFactory.newRsf(System.in);
    int dim = iput.getDimension();

    float[] olap = null;
    int  [] psze = null;
    switch (dim) {
    case 2:
      olap = cmd.getFloatArray("olap", "0.5f, 0.5f");
      psze = cmd.getIntArray  ("psze", "8,2");
      break;
    case 3:
      olap = cmd.getFloatArray("olap", "0.5f, 0.5f, 0.5");
      psze = cmd.getIntArray  ("psze", "8,8,2");
      break;
    default:
      System.err.println("Error: dimension not implemented");
      break;
    }
    int wantedResult = cmd.getInt("comp","0");

    OperatorFactory  opFac = new DipXGradFactory(wantedResult);
    PatchPushOp      pchOp = new PatchPushOp((RsfSpace) iput.getSpace(), 
					     olap, psze, opFac);

    Rsf oput = (Rsf) pchOp.image(iput);                     // image quilt 
    oput.write(System.out);
  } 
} 





