package   cohy.estDip;

import 	  rsf.vector.*;
import  juice.util.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class DipXGradTest {
  public static void main(String[] args) {

    int[] ind2 = {0, 0   };
    int[] ind3 = {0, 0, 0};

    boolean correct = true;

    System.out.println("2-D test");
    Rsf2 iput2 = (Rsf2) RsfFactory.newRsf(2,2);
    iput2.d[0][0] =  1.f;    iput2.d[1][0] =  3.f;
    iput2.d[0][1] =  2.f;    iput2.d[1][1] =  4.f;

    iput2.d[0][0] =  1.f;    iput2.d[1][0] =   1.f;
    iput2.d[0][1] = -1.f;    iput2.d[1][1] =  -1.f;

    DipXGrad oper2 = new DipXGrad((RsfSpace) iput2.getSpace());
    Rsf          oput2 = (Rsf) oper2.getRange().newMember();
    oper2.image(iput2,oput2); 

    if (oput2.getDatum(ind2) !=  0) correct = false;
    System.out.println("res should be  0: " + oput2.getDatum(ind2));

    System.out.println("3-D test");
    int[] smpl = {2,2,2}; 
    Rsf3 iput3 = (Rsf3) RsfFactory.newRsf(smpl);

    iput3.d[0][0][0] =   0.f;    iput3.d[1][0][0] =   1.f;
    iput3.d[0][1][0] =   1.f;    iput3.d[1][1][0] =   2.f;
    iput3.d[0][0][1] =   1.f;    iput3.d[1][0][1] =   2.f;
    iput3.d[0][1][1] =   2.f;    iput3.d[1][1][1] =   3.f;
    /*
    iput3.d[0][0][0] =   1.f;    iput3.d[1][0][0] =   1.f;
    iput3.d[0][1][0] =   1.f;    iput3.d[1][1][0] =   1.f;
    iput3.d[0][0][1] =  -1.f;    iput3.d[1][0][1] =  -1.f;
    iput3.d[0][1][1] =  -1.f;    iput3.d[1][1][1] =  -1.f;
    */
    DipXGrad oper3 = new DipXGrad((RsfSpace) iput3.getSpace());
    Rsf          oput3 = (Rsf) oper3.getRange().newMember();
    
    oper3.set3DToX();
    oper3.image(iput3,oput3); 
    if (oput3.getDatum(ind3) !=  0) correct = false;
    System.out.println("x res should be  0: " + oput3.getDatum(ind3));

    oper3.set3DToY();
    oper3.image(iput3,oput3); 
    if (oput3.getDatum(ind3) !=  0) correct = false;
    System.out.println("y res should be  0: " + oput3.getDatum(ind3));

    oper3.set3DToZ();
    oper3.image(iput3,oput3); 
    if (oput3.getDatum(ind3) !=  0) correct = false;
    System.out.println("z res should be  0: " + oput3.getDatum(ind3));

    System.err.println("Sample (1,1,0) deviates from plane-wave");
    iput3.d[0][0][0] =   0.f;    iput3.d[1][0][0] =   1.f;
    iput3.d[0][1][0] =   1.f;    iput3.d[1][1][0] =  12.f;
    iput3.d[0][0][1] =   1.f;    iput3.d[1][0][1] =   2.f;
    iput3.d[0][1][1] =   2.f;    iput3.d[1][1][1] =   3.f;

    oper3.set3DToX();
    oper3.image(iput3,oput3); 
    correct = JuiceUtil.approx(oput3.getDatum(ind3), 4.76838e-07f);
    System.out.println("x res should be 4.76837e-07: "+ oput3.getDatum(ind3));

    oper3.set3DToY();
    oper3.image(iput3,oput3); 
    correct = JuiceUtil.approx(oput3.getDatum(ind3), -7.15257e-07f);
    System.out.println("y res should be -7.15256e-07: "+ oput3.getDatum(ind3));

    oper3.set3DToZ();
    oper3.image(iput3,oput3); 
    correct = JuiceUtil.approx(oput3.getDatum(ind3), -4.76838e-07f);
    System.out.println("z res should be -4.76837e-07: "+ oput3.getDatum(ind3));

    Tester.exit(correct);
  }
}

