package   cohy.estPef;

import 	  sep.operator.*;
import    jam.vector.*;
import 	  rsf.vector.*;
import   cohy.gradient.*;
import   pef.pef.*;
import   sep.io.ArgumentKeeper;

/**
 * Computes the compound of the three 2D PEF filter and its adjoint.<BR>
 * The output is always equal to the input vector. 
 * 
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class XPefAndAdj extends SepOperator{
  RsfSpace xspc = new RsfSpace(4,2,1);
  RsfSpace yspc = new RsfSpace(4,1,2);
  RsfSpace zspc = new RsfSpace(1,4,2);
  int      iter = 10;

  public XPefAndAdj(RsfSpace iputSpace) {
    this(iputSpace, iputSpace);
  }
  public XPefAndAdj(RsfSpace iputSpace, RsfSpace oputSpace) {
    super(iputSpace, oputSpace);
  }
  protected XPefAndAdj(XPefAndAdj src) {
    super(src);
  }
  public jam.JamObject copy() { return new XPefAndAdj(this);}

  public static RsfSpace getOutputRsfSpace(RsfSpace iputSpace) {
    return new RsfSpace(iputSpace); 
  }
  public static RsfSpace getInputRsfSpace(RsfSpace oputSpace) {
    return new RsfSpace(oputSpace); 
  }

  protected void apply(boolean add, Vector iput, Vector oput) {

    IcaiPef oper; IcaiPefFactory fact; Rsf temp; 

    fact = new IcaiPefFactory(xspc, iter);
    oper = (IcaiPef) fact.getOpWithDomain(iput.getSpace());
    temp = (Rsf) oper.getRange().newMember();
    oper.image(iput, temp);
    oper.adjoint().addImage(temp, oput); 

    fact = new IcaiPefFactory(yspc, iter);
    oper = (IcaiPef) fact.getOpWithDomain(iput.getSpace());
    temp = (Rsf) oper.getRange().newMember();
    oper.image(iput, temp);
    oper.adjoint().addImage(temp, oput); 
      
    fact = new IcaiPefFactory(zspc, iter);
    oper = (IcaiPef) fact.getOpWithDomain(iput.getSpace());
    temp = (Rsf) oper.getRange().newMember();
    oper.image(iput, temp);
    oper.adjoint().addImage(temp, oput); 
  }
}


