package   cohy.estPef;

import 	  jam.vector.*;
import 	  jam.operator.*;
import 	  rsf.vector.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class XPefLocalNormFactory implements OperatorFactory {
  RsfSpace pefSpace;

  public XPefLocalNormFactory(RsfSpace pefSpace) {
    this.pefSpace = pefSpace; 
  }

  public Space createRange (   Space domain){ 
    return createRange((RsfSpace) domain); 
  }
  public Space createRange (RsfSpace domain){
    int n = domain.getDimension();
    Axis[] axs = new Axis[n];
    for (int i = 0 ; i < n ; i++) {
      axs[i]          = new Axis(domain.getAxes()[i]);
      axs[i].nsamples = domain.getNSamples(i) - pefSpace.getNSamples(i) + 1;
    }
    return new RsfSpace(axs); 
  }
  public Space createDomain(   Space range){ 
    return createDomain((RsfSpace) range); 
  }
  public Space createDomain(RsfSpace range){
    int n = range.getDimension();
    Axis[] axs = new Axis[n];
    for (int i = 0 ; i < n ; i++) {
      axs[i]          = new Axis(range.getAxes()[i]);
      axs[i].nsamples = range.getNSamples(i) + pefSpace.getNSamples(i) -1;
    }
    return new RsfSpace(axs); 
  }

  public Operator getOp(Space domain, Space range){
    return new XPefLocalNorm((RsfSpace) domain, 
			     (RsfSpace) range, 
			     (RsfSpace) pefSpace);
  }
  public Operator getOpWithRange(Space  range){
    return new XPefLocalNorm((RsfSpace) this.createDomain(range), 
			     (RsfSpace) range,
			     (RsfSpace) pefSpace);
  }
  public Operator getOpWithDomain(Space domain){
    return new XPefLocalNorm((RsfSpace)domain, 
			     (RsfSpace) this.createRange(domain),
			     (RsfSpace) pefSpace);
  }
}




