package cohy.estPef;

import   jam.operator.*; 
import   rsf.vector.*;
import   rsf.operator.*; 
import   sep.io.ArgumentKeeper;
import  nstat.patch.*;

public class XPefLocalNormNStat { 
  /** 
   * @param olap=.5f,.5f.5f float array of overlap values 
   * @param psze=12,12,12   int   array of patch size 
   * @param pefi=4,4,4   int   array of pef   size 
   */ 
  public static void main(String[] args) {
    ArgumentKeeper cmd = new ArgumentKeeper(args); 

    Rsf iput = RsfFactory.newRsf(System.in);
    int dim  = iput.getDimension();

    float[] olap = cmd.getFloatArray("olap", "0.5f, 0.5f, 0.5");
    int[]   psze = cmd.getIntArray  ("psze", "12,12,12");
    int[]   pefi = cmd.getIntArray  ("pefi", "4,4,4"   );

    OperatorFactory  opFac = new XPefLocalNormFactory(new RsfSpace(pefi));
    PatchPushOp      pchOp = new PatchPushOp((RsfSpace) iput.getSpace(), 
					     olap, psze, opFac);
    Rsf oput = (Rsf) pchOp.image(iput);                     // image quilt 
    oput.write(System.out);
  } 
} 

