package   cohy.gradient;

import 	  rsf.vector.*;
import    sep.io.*;

/**
 * Implements a simple 4-point difference star with adjustable coefficients.
 * This could have been easily written as a internal convolution with 
 * a 2-by-2 filter. 
 * <BR>
 * output = (dx Dx + dt Dt) input (Dx and Dt are partial differential ops).
 *
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class PartDiff1d {

  private static Rsf1 newRsf() {
    int[] sz = {2};
    return (Rsf1) RsfFactory.newRsf(sz); 
  }

  public static Rsf getDerivative(float dx) { 
    Rsf1 rsf = newRsf(); float[] star = rsf.d;
    star[0] = - dx; star[1] =   dx;
    return rsf;
  }
  public static Rsf getDerivativeDx() { 
    Rsf1 rsf = newRsf(); float[] star = rsf.d;
    star[0] = - 1.f; star[1] =   1.f;
    return rsf;
  }
  public static void main(String[] args) {
    ArgumentKeeper command = new ArgumentKeeper(args);

    float dx = command.getFloat("dx",1.f);

    Rsf oput = PartDiff1d.getDerivative(dx);
    oput.write(System.out); 
  }
}

