package  cohy.laplace;

import 	  jam.vector.*;
import 	  jam.operator.*;
import 	  rsf.vector.*;
import    rsf.operator.*;
import    sep.io.*;
import    conv.convi.*;

public class FilterAndNorm { 
  /**
   * FilterAndNorm filter=rsfFile norm=n > out.H <BR><BR>
   * @param filter specifies the filter to be used.<BR>
   * @param norm=y divides each output pixel of the convolution 
   *               by the sum of the absolute values 
   *               of all input pixels that 
   *               contributed to that output pixel.<BR>
   */
  public static void main(String[] args) { 

    ArgumentKeeper command = new ArgumentKeeper(args);

    String filter          = command.getString("filter");
    Rsf filt = RsfFactory.newRsf(filter); 
    Rsf iput = (Rsf3) RsfFactory.newRsf(System.in); 

    InternalConvolution myInternalConvolution =
      new InternalConvolution( InternalConvolution.kInput , 
			       (RsfSpace) iput.getSpace(),
			       InternalConvolution.kFilter,
			       (RsfSpace) filt.getSpace());

    Rsf oput1 = (Rsf) myInternalConvolution.imageBinary(iput, filt);
    ((RsfSpace) oput1.getSpace()).getDataAxis().label = "Edgy Output"; 
      
    String norm            = command.getString("norm");
    if (norm.equals("y")) {
      filt.fill(1.f);
      ElwAbs.elwAbs(iput); 
      Rsf oput2 = (Rsf) myInternalConvolution.imageBinary(iput, filt);
      ElwInv.elwInv(oput2); // ElwInv.elwInv(iput,1.0e-12f); // necessary???
      oput1.mul(oput2); 
    }
    oput1.write(System.out); 
  }
}
