package cohy.spgti;

import   rsf.vector.*;
import   sep.io.ArgumentKeeper;

public class SpaghettiSyn {
  public static void main(String[] args) {
    ArgumentKeeper argKeeper = new ArgumentKeeper(args);
    int n1   = argKeeper.getInt   ("n1"  , "50");
    int n2   = argKeeper.getInt   ("n2"  , "80");
    int n3   = argKeeper.getInt   ("n3"  , "80");

    float d1 = .004f, d2 = .065f, d3 = .065f;
    float o1 = .000f, o2 = .000f, o3 = .000f;
    Axis[] ax = new Axis[3];
    ax[0]     = new Axis(n1, d1 ,0.f, "time"  , "sec");
    ax[1]     = new Axis(n2, d2 ,0.f, "x-dist", "km" );
    ax[2]     = new Axis(n3, d3 ,0.f, "y-dist", "km" );
    Rsf rsf   = RsfFactory.newRsf(ax);

    float[][][] data = ((Rsf3)rsf).d; 
    int nevents = 1000;
    for (int i=0; i<nevents; i++) {
      double ampl =    2. * Math.random(); 
      double sigm =  100. * Math.random();
      double x0   = n2*d2 * Math.random();
      double y0   = n3*d3 * Math.random();
      for (int i3=0; i3<n3; i3++) { double y = o3 + i3 * d3; 
      for (int i2=0; i2<n2; i2++) { double x = o2 + i2 * d2;  
	data[i3][i2][0] += ampl * 
	  Math.exp(-sigm*sigm * ((x-x0)*(x-x0) + (y-y0)*(y-y0)));
      }}
    }

    for (int i3=0; i3<n3; i3++) { 
    for (int i2=0; i2<n2; i2++) { 
    for (int i1=1; i1<n1; i1++) { 
      data[i3][i2][i1] = data[i3][i2][0];
    }}}
    rsf.write(System.out); 
  }
}
