package  geom.proj;

import   rsf.vector.*;
import   juice.util.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class PlaneWaveTest {
  public static void main(String[] argv) {

    boolean correct = true;

    System.out.println("We create a 2D data set with 1 plane wave");

    // The two locations are equal because n*x1 = n*x2 
    // where x1=loc21, x2=loc22, n=stepout21. 
    // First array location is fastest.
    //float[] stepout21 = {1.f,-2.f}; // RSF INDX SHIT (x,y,z) 
    float[] stepout21 = {-2.f,1.f}; // -2 refers to slow index which 4 below.
    int[] loc21      = { 8, 4}; // loc21[0] = 8; consequently refers to d[4][8]
    int[] loc22      = {10, 5}; // (z,y,x) 

    Rsf data2 = RsfFactory.newRsf(50,25);
    PlaneWave generator = new PlaneWave((RsfSpace) data2.getSpace()); 
    generator.setStepout(stepout21);
    generator.addImage(data2,data2); 

    System.out.println("At " + JuiceUtil.arrayToString(loc21,",") + ": " + 
		       data2.getDatum(loc21)); 
    System.out.println("At " + JuiceUtil.arrayToString(loc22,",") + ": " + 
		       data2.getDatum(loc22)); 
    if ( data2.getDatum(loc21) != data2.getDatum(loc22) ) correct = false;

    System.out.println("Now we add another plane wave");

    float[] stepout22 = {2.f, 1.f}; // (x,y,z)
    generator.setTraceFilter(rsf.util.Tent.newRsf(7));
    generator.setStepout(stepout22);
    generator.addImage(data2,data2); 

    data2.write("plane2.H");
    System.out.println(data2);

    System.out.println("We create a 3D data set with 1 plane wave");

    // The two locations are equal because n*x1 = n*x2 
    // where x1=loc31, x2=loc32, n=stepout31. 
    // First array location is fastest.
    float[] stepout31 = {-1.f,-1.f,1.f}; // (x,y,z)
    int[] loc31      = {8,4,4};          // (z,y,x)
    int[] loc32      = {10,5,5};         // (z,y,x)

    Rsf data3 = RsfFactory.newRsf(15,10,10);
    PlaneWave generator3 = new PlaneWave((RsfSpace) data3.getSpace()); 
    generator3.setStepout(stepout31);
    generator3.addImage(data3,data3); 

    System.out.println("At " + JuiceUtil.arrayToString(loc31,",") + ": " + 
		       data3.getDatum(loc31)); 
    System.out.println("At " + JuiceUtil.arrayToString(loc32,",") + ": " + 
		       data3.getDatum(loc32)); 
    if ( data3.getDatum(loc31) != data3.getDatum(loc32) ) correct = false;

    float[] stepout32 = {1.f, 1.f, 1.f}; 
    generator3.setStepout(stepout32);
    generator3.addImage(data3,data3); 

    data3.write("plane3.H");

    Tester.exit(correct);
  }
}

