package geom.proj;

import   sep.io.ArgumentKeeper;
import   rsf.vector.*;

/**
 * Computes a Plane-wave cube. Alternatively, check geom.shift.PlaneWaveVol.
 */
public class PlaneWaveVol {
  public static void main(String[] args) {
    ArgumentKeeper cmd = new ArgumentKeeper(args);
    int[]   n = cmd.getIntArray("n","50,80,80"); 
    float[] nf = cmd.getFloatArray("nf","1.f,.39f,-1.f"); 

    float  d1  = .004f, d2 = .065f, d3 = .065f;
    float  o1  = .000f, o2 = .000f, o3 = .000f;
    Axis[] ax  = new Axis[3];
    ax[0]      = new Axis(n[0], d1 ,0.f, "time"  , "sec");
    ax[1]      = new Axis(n[1], d2 ,0.f, "x-dist", "km" );
    ax[2]      = new Axis(n[2], d3 ,0.f, "y-dist", "km" );
    Rsf    dat = RsfFactory.newRsf(ax);

    PlaneWave generator = new PlaneWave((RsfSpace) dat.getSpace()); 
    generator.setTraceFilter(rsf.util.Tent.newRsf(7)); 
    //generator.setTraceFilter(rsf.util.Tent.newRsf(17)); 
    generator.setStepout(nf);
    generator.addImage(dat,dat); 
    dat.setTitle(cmd.getString("rsfName","Plane_wave"));
    dat.write(System.out); 
  }
}
