package  geom.proj;
import   geom.simple.*;
import   rsf.vector.*;
import   rsf.operator.*;
import   sep.io.ArgumentKeeper;

/**
 * Warning: <BR>
 *          this is suppose to replace Jon's make.HH. Unfortunately, 
 *          the data I yield is less predictable as you can test 
 *          easily in miss/misnonlinF: try ../Data/make.HH.old (Jon's 
 *          original and ../Data/make.HH. The two fill ins are not 
 *          even close. Try PlaneWave without back projection and 
 *          shifting by integers.<BR>
 * 
 * Synthetic data set with ascending and descending planar events.
 * SynSatTrac > out.H 
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class SynSatTrac {
  public static void main(String[] args) {
    ArgumentKeeper argKeeper = new ArgumentKeeper(args);
    Rsf dipdat = RsfFactory.newRsf(100,20); 
    PlaneWave generator = new PlaneWave((RsfSpace) dipdat.getSpace()); 
    // generator.setFilter(rsf.util.Tent.newRsf(3));
    // generator.setTraceType(TraceGenerator.IMPEDANCE);
    float[] stepout1 = {1.f,-1.f};
    generator.setStepout(stepout1); 
    generator.addImage(dipdat,dipdat);
    float[] stepout2 = {1.f, 1.f};
    generator.setStepout(stepout2); 
    generator.addImage(dipdat,dipdat);
    dipdat.setTitle("Superposed_Waves");
    if (argKeeper.containsKey("out")) {
      dipdat.write(argKeeper.getString("out"));
    }
    else {
      dipdat.write(System.out);
    }
  }
}

