package  geom.shift;

import  java.util.Random;
import   rsf.vector.*;
import   rsf.operator.*;
import   rsf.util.*;
import   sep.io.ArgumentKeeper;

/**
 * Creates a synthetic 2-D data set that simulates ascending and 
 * descending planar events (Similar to satelite tracks). 
 * The original program was written in Ratfor by Jon.<BR> 
 * 
 * SynSatTrac > out.H 
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class SynSatTrac {
  public static void main(String[] args) {
    ArgumentKeeper cmd = new ArgumentKeeper(args);
    int n0 = cmd.getInt("n0",100);
    int n1 = cmd.getInt("n1", 20);
    Rsf2 dipdat = (Rsf2) RsfFactory.newRsf(n0,n1); 

    Rsf1 s1 = (Rsf1) RsfFactory.newRsf(3*n0); 
    Rsf1 s2 = (Rsf1) RsfFactory.newRsf(3*n0); 
    s1.rand(new Random(2001)); ElwPow.elwPow(s1,3.);
    s2.rand(new Random(1999)); ElwPow.elwPow(s2,3.);    
    //s1 = (Rsf1) Convolver.convolve(Tent.newRsf(4), s1);
    //s2 = (Rsf1) Convolver.convolve(Tent.newRsf(4), s2);

    for (int i1 = 0; i1 < n1; i1++) {
    for (int i0 = 0; i0 < n0; i0++) {
      dipdat.d[i1][i0]  = s1.d[i0 + n0 +   i1];
      dipdat.d[i1][i0] += s2.d[i0 + n0 - 2*i1];
    } }
    dipdat.setTitle("Superposed_Waves");
    dipdat.write(System.out);
  }
}

