package  geom.simple;
import   rsf.vector.*;
import   sep.io.*;

/** 
 * This class generates a synthetic Rsf with a constant amplitude.<BR> 
 * <BR><!--#include file="./source.inc"--><BR>
 * @author Matthias Schwab
 */
public class Const {
  /**
   * @param const=[1.f] constant amplitude value
   * @param n=80,80,80  nsamples
   * @param out=fname   output written to file: default is System.out. 
   */
  public static void main(String[] args) {
    ArgumentKeeper cmd = new ArgumentKeeper(args);
    Rsf data = RsfFactory.newRsf(cmd.getIntArray("n","80,80,80"));
    data.fill(cmd.getFloat("const",1.f));
    if (cmd.containsKey("out")) data.write(cmd.getString("out")); 
    else                        data.write(System.out); 
  }
} 
