package  geom.simple;

import   rsf.vector.*;
import   rsf.operator.*;

/**
 * Punches ellipsoidal hole in data.<BR> 
 * Puncher < in.H > out.H 
 *
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class Puncher {
  public static void main(String[] args) {
    Rsf data    = RsfFactory.newRsf(System.in); 
    int n0      = data.getAxis(0).nsamples;
    int n1      = data.getAxis(1).nsamples;
    float[][] d = ((Rsf2) data).d;
    for   (int i1=0; i1<n1; i1++) { float y = -.3f + (float) i1 / n1 ;
      for (int i0=0; i0<n0; i0++) { float x = -.5f + (float) i0 / n0 ;
        float u =  x + y;
	float v = (x - y) / 2.f;
	if (u*u + v*v < .15f) {
	  d[i1][i0] *= 0.f;
	} 
	else {
	  d[i1][i0] *= 1.f; 
	}
      } 
    }
    data.setTitle("Missing_Data"); 
    data.write(System.out); 
  }
}

