package geom.simple;

import rsf.vector.*;
import sep.io.*;
import geom.simple.*;

/**
 * Creates a textured synthetic data set. 
 * This could be an operator class. Maybe it should.
 * 
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class SynFolt {

  public static void main(String[] args) {
    ArgumentKeeper cmd = new ArgumentKeeper(args);
    // thickness is in vertical samples! 
    int thck = 0; boolean isThick = false; 

    Rsf3 folt = null;
    if (cmd.containsKey("folt")) { 
      thck = 10; 
      isThick = true;
      folt = (Rsf3) RsfFactory.newRsf(cmd.getString("folt"));
    }

    if (! cmd.containsKey("left")) 
      System.err.println("Error: missing arg left");
    Rsf3 left = (Rsf3) RsfFactory.newRsf(cmd.getString("left"));

    if (! cmd.containsKey("rght")) 
      System.err.println("Error: missing arg rght");
    Rsf3 rght = (Rsf3) RsfFactory.newRsf(cmd.getString("rght"));

    //float[] nf = {-2.f,  3.f, 1.f}; 
    float[] nf = { 1.f,-.39f,-1.f}; 
    float norm = 0.f; 
    for (int i=0; i<nf.length; i++)  norm += nf[i]*nf[i]; 
    norm = (float) Math.sqrt(norm);
    float nf0 = nf[0]/norm; 
    float nf1 = nf[1]/norm; 
    float nf2 = nf[2]/norm; 

    if ( nf0 == 0.f ) System.err.println("Error: no vertical line!");
    if ( nf0  < 0.f ) System.err.println("Error: only ascending fault!");

    // I add to the lft Rsf the other features as desired 

    int n0 = rght.getAxis(0).nsamples; float h0 = n0/2.f;
    int n1 = rght.getAxis(1).nsamples; float h1 = n1/2.f;
    int n2 = rght.getAxis(2).nsamples; float h2 = n2/2.f;

    if (isThick) {
    float hn = h0 * nf0 + h1 * nf1 + h2 * nf2;
    for     (int i2=0; i2<n2; i2++) { float d2 =  hn - i2 * nf2;
      for   (int i1=0; i1<n1; i1++) { float d1 = (d2 - i1 * nf1) / nf0;
        for (int i0=0; i0<n0; i0++) { int    i = (int) d1; float w = d1 - i;
	  if (d1 < 0.f) i = -1; 

	  if(i0 == i)    {
	    left.d[i2][i1][i0] =  (    w) * left.d[i2][i1][i0] + 
	                          (1.f-w) * folt.d[i2][i1][i0];
	  } 
	  if (i0 > i) {
	    left.d[i2][i1][i0] =            folt.d[i2][i1][i0];
	  }
    } } } 
    }

    h0 += thck; 
    float hn = h0 * nf0 + h1 * nf1 + h2 * nf2;
    for     (int i2=0; i2<n2; i2++) { float d2 =  hn - i2 * nf2;
      for   (int i1=0; i1<n1; i1++) { float d1 = (d2 - i1 * nf1) / nf0;
        for (int i0=0; i0<n0; i0++) { int    i = (int) d1; float w = d1 - i;
	  if (d1 < 0.f) i = -1; 

	  if(i0 == i)    {
	    left.d[i2][i1][i0] =  (    w) * left.d[i2][i1][i0] + 
	                          (1.f-w) * rght.d[i2][i1][i0];
	  } 
	  if (i0 > i) {
	    left.d[i2][i1][i0] =           rght.d[i2][i1][i0];
	  }
    } } } 

    left.setTitle(cmd.getString("rsfName","Synthetic")) ; 
    left.write(System.out); 
  }
}

