package   pef.pef;

import 	  jam.vector.*;
import 	  jam.operator.*;
import 	  rsf.vector.*;

/**
 * Instantiates a IcaiPef operator. 
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class IcaiPefFactory implements OperatorFactory {
  RsfSpace pefSpace; 
  int      iter;

  public IcaiPefFactory(RsfSpace pefSpace, int iter) {
    this.pefSpace = pefSpace;
    this.iter     = iter;
  }
  public Operator getOp(Space domain, Space range ){
    return new IcaiPef((RsfSpace) domain, (RsfSpace) range, pefSpace, iter); 
  }
  public Operator getOpWithRange(Space range){
    return new IcaiPef((RsfSpace)createDomain(range), 
                       (RsfSpace)              range, pefSpace, iter);
  }
  public Operator getOpWithDomain(Space domain){
    return new IcaiPef((RsfSpace)            domain, 
		       (RsfSpace)createRange(domain), pefSpace, iter);
  }

  public    Space createRange(   Space domain) { 
    return createRange((RsfSpace) domain);
  }
  public RsfSpace createRange(RsfSpace domain) {
    int n = domain.getDimension();
    Axis[] axs = new Axis[n];
    for (int i = 0 ; i < n ; i++) {
      axs[i]          = new Axis(domain.getAxes()[i]);
      axs[i].nsamples = domain.getNSamples(i) - pefSpace.getNSamples(i) + 1;
    }
    return new RsfSpace(axs); 
  }

  public    Space createDomain(   Space range) { 
    return createDomain((RsfSpace) range);
  }
  public RsfSpace createDomain(RsfSpace range) {
    int n = range.getDimension();
    Axis[] axs = new Axis[n];
    for (int i = 0 ; i < n ; i++) {
      axs[i]          = new Axis(range.getAxes()[i]);
      axs[i].nsamples = range.getNSamples(i) + pefSpace.getNSamples(i) -1;
    }
    return new RsfSpace(axs); 
  }
}




