package pef.pef;

import   jam.operator.*; 
import   rsf.vector.*;
import   rsf.operator.*; 
import   sep.io.ArgumentKeeper;
import  nstat.patch.*;

public class IcaiPefNStat { 
  /** 
   * @param olap=.5f,.5f float array of overlap values 
   * @param psze=8,2     int   array of patch size 
   */ 
  public static void main(String[] args) {
    ArgumentKeeper cmd = new ArgumentKeeper(args); 

    Rsf iput = RsfFactory.newRsf(System.in);
    int dim  = iput.getDimension();
    float[] olap = null;
    int  [] psze = null;
    int  [] fsze = null;
    int     iter =    1; 
    switch (dim) {
    case 2:
      olap = cmd.getFloatArray("olap", "0.5f, 0.5f");
      psze = cmd.getIntArray  ("psze", "8,2");
      fsze = cmd.getIntArray  ("fsze", "2,2");
      iter = cmd.getInt       ("iter",  3     );
      break;
    case 3:
      olap = cmd.getFloatArray("olap", "0.5f, 0.5f, 0.5");
      psze = cmd.getIntArray  ("psze", "8,8,2");
      fsze = cmd.getIntArray  ("fsze", "2,2,2");
      iter = cmd.getInt       ("iter",  6     );
      break;
    default:
      System.err.println("Error: dimension not implemented");
      break;
    }

    OperatorFactory  opFac = new IcaiPefFactory(new RsfSpace(fsze),iter);
    PatchPushOp      pchOp = new PatchPushOp((RsfSpace) iput.getSpace(), 
					     olap, psze, opFac);

    Rsf oput = (Rsf) pchOp.image(iput);                     // image quilt 
    oput.write(System.out);
  } 
} 





