package book.convi;

import rsf.vector.*;
import   jag.util.Tester;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
final
public class InternalConvolutionTest {
  public static void main(String[] args) {
    Tester.exit(test(args));
  }

  public static int  test(String[] args) {
    Axis[] ax = new Axis[2];
    ax[0] = new Axis( 3, 1f, 0f, "time", "s" );
    ax[1] = new Axis( 4, 2f, 0f, "distance", "m" );

    Axis[] filtAx = new Axis[2];
    filtAx[0] = new Axis( 2, 1f, 0f, "", "" );
    filtAx[1] = new Axis( 2, 1f, 0f, "", "" );

    Rsf inRsf = (Rsf) new Rsf(ax);
    inRsf.zero();
    int[] ind = {1,1};
    inRsf.d[ inRsf.i( ind)] =  1f;
    Rsf filt  = new Rsf(filtAx);
    filt.fill(1f);
    ind[0] = 1; ind[1] = 0;
    filt .d[ filt .i( ind)] = -1f;
    ind[0] = 0; ind[1] = 1;
    filt .d[ filt .i( ind)] = -1f;
    
    InternalConvolution myInternalConvolution =
      new InternalConvolution( InternalConvolution.inputSpace ,
			       (RsfSpace) inRsf.getSpace()    ,
			       InternalConvolution.filterSpace,
			       (RsfSpace) filt .getSpace()    );
    Rsf  outRsf = (Rsf) myInternalConvolution.image(inRsf, filt);
    System.out.println( outRsf);

    Rsf ideal = new Rsf( (RsfSpace) outRsf.getSpace());
    ideal.d[0] = 1;
    ideal.d[1] = -1;
    ideal.d[2] = -1;
    ideal.d[3] = 1;
    ideal.d[4] = 0;
    ideal.d[5] = 0;

    return (outRsf.equals(ideal) == true ? 0:1);
  }
}

/* // this is another test routine: it is large for timing
final
public class InternalConvolutionTest {
  public static void main( String[] args) {
    Axis[] ax = new Axis[2];
    ax[0] = new Axis( 50, 1f, 0f, "time", "s" );
    ax[1] = new Axis( 50, 2f, 0f, "distance", "m" );

    Axis[] filtAx = new Axis[2];
    filtAx[0] = new Axis( 10, 1f, 0f, "", "" );
    filtAx[1] = new Axis( 10, 1f, 0f, "", "" );

    Rsf inRsf = new Rsf(    ax).setRandom();
    Rsf filt  = new Rsf(filtAx).setRandom();
    
    InternalConvolution myInternalConvolution =
      new InternalConvolution( "input" , (RsfSpace) inRsf.getSpace(),
                               "filter", (RsfSpace) filt .getSpace());
    Rsf outRsf =
      new Rsf( InternalConvolution.
               createOutputSpace((RsfSpace) inRsf.getSpace(),
                                 (RsfSpace) filt .getSpace()));
    myInternalConvolution.image( inRsf, filt, outRsf);
    System.out.println( "Done JAVA.");
  }
} */
