package  book.nmo;

import   book.factory.SepLinearOperatorAdjoint;
import 	 jag.vector.*;
import 	 jag.operator.*;
import 	 rsf.vector.*;

/**
 * Are these classes to complicated? We definitely need a 
 * simple NMO operator. What are alternative combinations 
 * of a linear Nmo step and a nonlinear velocity analysis 
 * step? I would like to have the simple Nmo being wrapped 
 * and reused by a non-linear operator. Currently we store 
 * the nmo code in the evil overloard operator Nmo.apply().
 *
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class NmoV extends SepLinearOperatorAdjoint {
  protected Rsf stkVel;

  /**
   * The caller must set the adjoint after construction
   * Joel, this adjoint scheme is to complicated. We have to think of 
   * something simpler. 
   */
  public NmoV(Rsf stkVel, RsfSpace nmoMdlSpc, RsfSpace cmpDatSpc, boolean isFwd) {
    super();
    this.stkVel = stkVel;
    setInput  (nmoMdlSpc);
    setOutput (cmpDatSpc);
    setForward(isFwd);
    setAdjoint(null);
    //    this.adj = new NmoV("adjoint", this);
  }

  public NmoV(Vector stkVel, Space nmoMdlSpc, Space cmpDatSpc, boolean isFwd) {
    this((Rsf) stkVel, (RsfSpace) nmoMdlSpc, (RsfSpace) cmpDatSpc, isFwd);
  }
  protected void setAdjoint(OperatorAdjoint adj) {super.setAdjoint(adj);}

  void apply(boolean add, Vector nmoMdl, Vector cmpDat) {
    Nmo.apply(isFwd, add, this.stkVel, (Rsf) nmoMdl, (Rsf) cmpDat);
if(!isFwd) {
float x2x = ((Rsf) nmoMdl).getDatum(0,0);
System.err.println("Nmo1: sample 0: " + x2x + "\n");
}
    /*
    if (isFwd) {
      System.err.println("isFwd: " + isFwd + "\n"      + "\n" +
			 "stkVel " + stkVel.getSpace() + "\n" +
			 "input: " + nmoMdl.getSpace() + "\n" +
			 "output:" + cmpDat.getSpace() );
    }
    else {
      System.err.println("isFwd: " + isFwd + "\n"      + "\n" +
			 "stkVel " + stkVel.getSpace() + "\n" +
			 "input: " + cmpDat.getSpace() + "\n" +
			 "output:" + nmoMdl.getSpace() );
    }
    */
  }
}





