package book.nmo;

import rsf.vector.*;
import sep.io.*;
import java.net.*;
import java.io.*;

public class NmoVTest {
  protected float velocity = 1.4F;

  public static void main(String[] args) {
    ArgumentKeeper params = new ArgumentKeeper(args);

    Rsf      iput    = new Rsf("../Data/cmp.HH");
    Rsf      oput    = new Rsf(new RsfSpace((RsfSpace) iput.getSpace()));
    ((RsfSpace) oput.getSpace()).getAxes()[0].label = "tau(seconds)";

    Axis[]   veloAxs = {new Axis(((RsfSpace) iput.getSpace()).getAxes()[0])};
    RsfSpace veloSpc = new RsfSpace(veloAxs);
    Rsf      veloVec = new Rsf(veloSpc);
    veloVec.fill(1.4F); 
    ((RsfSpace) veloVec.getSpace()).getAxes()[0].label = "vel(seconds)";

    NmoV fwd = new NmoV(veloVec, iput.getSpace(), oput.getSpace(), true );
    NmoV adj = new NmoV(veloVec, iput.getSpace(), oput.getSpace(), false);
    fwd.setAdjoint(adj);
    adj.setAdjoint(fwd);
    
    fwd.image(iput, oput);
    fwd.adjoint().image(oput, iput); 
  }
}
