package proc.opalias;
import rsf.vector.*;
import sep.io.*;

/** 
 * This a very simple Anti-aliasing tool. It plugs in at the 
 * loop level and it takes a single maximum slope argument.
 * Interesting topic for some more research. 
 * I lack a generalization from 2-D to higher dimensions. 
 */ 
public class Alias {
  public static void main(String[] args) {
    ArgumentKeeper cmd = new ArgumentKeeper(args); 
    Rsf2 data = (Rsf2) RsfFactory.newRsf(100,120); 
    float cur = .05f; 
    for (int i1=0; i1 < 120; i1++) {
      int i0 = (int) (cur * Math.pow(i1 - 33, 2) + 12);
      int sl = (int) (2 * cur *      (i1 - 33)       ); 
      int[] ind = {i0,i1}; 
      String anti = cmd.getString("anti","y"); 
      if (anti.equals("n")) if (i0 < 100) data.setDatum(ind, 1.f);
      if (anti.equals("y")) if (i0 < 100) alias(data, ind, 1.f, sl); 
    }
    data.write(System.out); 
  }

  /** 
   * for higher dimensions this is only sufficient to prevent aliasing 
   * in 2-D.
   */
  static void alias( Rsf data, int[] index, float val, int slope ) { 
    int max =  (slope > 0 ?  slope : - slope ); 
    int min = - max;
    int cen = index[0];
    for (int i = min; i <= max; i++) {
      index[0] = cen + i; 
      if (index[0] >= 0 && index[0] < data.getAxis(0).nsamples) {
	data.setDatum( index,val * (1.f - Math.abs(i) / (max+1.f)) );
      }  
    }
  }
}

