package proc.web;

import   rsf.vector.*;
import   sep.io.*;
import	java.net.*;
import	java.io.*;

public class Results {
  static final int STRETCHinput  = 0;
  static final int STRETCHoutput = 1;
  Rsf               stretchInput;
  protected boolean local;
  protected float   velocity;

  public Results()              { this(false); }
  public Results(boolean local) {
    this.local = local;
    stretchInput = null;
    setVelocity(1.4F);
  }
  public void setVelocity(float vel) { velocity = vel; }

  public static void main(String[] args) {
    ArgumentKeeper params = new ArgumentKeeper(args);

    Rsf stretch = (Rsf) new Results(true).getResults(STRETCHoutput);
    stretch.write(params.getString("out"));
  }

  public Object getResults(int res) {
    if (res == STRETCHinput ) { return getStretchInput(); }
    if (res == STRETCHoutput) { return getStretchOutput(getStretchInput()); }
    return null;
  }

  public Rsf getStretchInput() {
    if (stretchInput == null) {
      String relPath = "./cmp.HH";
      String urlPath = "http://sepwww.stanford.edu/sep/matt/sdi/"
	+ "proc/web/" + relPath;
      Rsf ipt = null;
      if (local) stretchInput = RsfFactory.newRsf(relPath);
      else {
	try {
	  URL  data = new URL("http://sepwww.stanford.edu/sep/matt/sdi/proc/web/cmp.HH");
	  stretchInput = RsfFactory.newRsf(data.openStream());
	} catch (Exception e) { System.err.println(e); }
      }
    }
    return stretchInput;
  }

  public Rsf getStretchOutput(Rsf input) {
    RsfSpace spc = (RsfSpace) input.getSpace();
    System.out.println("I move out the gather");
    Nmo myNmo = new Nmo(spc, velocity);

    return (Rsf) myNmo.image(input);
  }
}
