package proc.web;

import 	rsf.vector.*;
import  gag.xtpF.*;
import  java.awt.*;

public class Viewer extends Xtp {
  float velocity;

  public Viewer() {
    super(new Vexec());
    velocity = 1.4F;
    this.add(new Button("<"));
    this.add(new Button(">"));
  }
      
  public boolean action(Event e, Object arg) {
    if (arg.equals("<")) {
      velocity -= 0.05F;
      ((Vexec) executor).showFrame(velocity);
      return true;
    }
    if (arg.equals(">")) {
      velocity += 0.05F;
      ((Vexec) executor).showFrame(velocity);
      return true;
    }
    return super.action(e, arg);
  }

  public static void main(String[] args) {
System.err.println("I am in main");
    Viewer viewer = new Viewer();
    viewer.resize(200,200);
    viewer.show();
  }
}

class Vexec extends Executor {
  Results res;

  public Vexec() {
    super();
    res = new Results();
  }

  public int view() {
    showFrame(1.4F);
    return 0;
  }

  public void showFrame(float vel) {
    rsfF.vector.Rsf
      ipt = RsfFactory.rsf2rsfF((Rsf) res.getResults(Results.STRETCHinput ));
    res.setVelocity(vel);
    rsfF.vector.Rsf
      opt = RsfFactory.rsf2rsfF((Rsf) res.getResults(Results.STRETCHoutput));

    RsfCanvas canv1 = new RsfCanvas(ipt, 300, 300, -1.e8F, 1.e8F);
    RsfCanvas canv2 = new RsfCanvas(opt, 300, 300, -1.e8F, 1.e8F);
    ResultFrame resFrame = new ResultFrame("Results", canv1);
    resFrame.add(canv2);
    resFrame.resize(600, 800);
    resFrame.show();
  }

  public int build() {
    System.out.println("We are currently accepting suggestions for the ");
    System.out.println("build behavior in the Java framework");
    return 0;
  }
  public int burn() {
    System.out.println("We are currently accepting suggestions for the ");
    System.out.println("burn behavior in the Java framework");
    return 0;
  }
  public int clean() {
    System.out.println("We are currently accepting suggestions for the ");
    System.out.println("clean behavior in the Java framework");
    return 0;
  }
  /*
  public int quit() {
    kill all Frames created with view;
    return super(quit());
  }
  */
}
